#CS
	:: Title: Golf Handicap Calculator
	:: Version: 1.0.0.0
	:: Compiler: AutoIT v3.1.0.15
	:: Author: S. Morgan "Radsam"
	:: Date: March 13, 2005
	:: Descrption: This application will calculate a users Handicap based on the minimum of 5 rounds of 18 hole golf.
	:: Calculation used: Handicap Differential = (Adjusted Gross Score - USGA Course Rating) x 113 / USGA Slope Rating
	After the Handicap Differential has been calculated for each of the 5 rounds, the lowest Differential will be
	multiplied by 0.96 to get the users handicap.
	:: Notes: Golf Handicap Calculator, only tested under Windows 2000 and XP.
	:: To Do's: - Save and Open calculated values
	            - Installer package
	:: Comments/Bugs/Suggestions: S. Morgan "Radsam" (stvmgn@yahoo.com)
#CE

#include <GuiConstants.au3>

Dim $iHandiCap

$sCHCTitle = "Golf HandiCap Calculator"
$iCHCWidth = 415 ; -1 = 400
$iGHCHeight = 280 ; -1 = 400
$iGHCLeftPos = -1 ;-1 is Center
$iGHCTopPos = -1 ;-1 is Center
$iGHCStyle = -1 ;-1 is default which is: $WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU
$iGHCExStyle = -1 ; -1 is default

$cGHChandle = GUICreate($sCHCTitle, $iCHCWidth, $iGHCHeight, $iGHCLeftPos, $iGHCTopPos, $iGHCStyle, $iGHCExStyle)
GUISetBkColor(0x5EA356)

$cFileMenu = GUICtrlCreateMenu("&File")
$cExitItem = GUICtrlCreateMenuItem("E&xit", $cFileMenu)
$cHelpMenu = GUICtrlCreateMenu("&Help")
$cAboutItem = GUICtrlCreateMenuItem("&About", $cHelpMenu)

GUICtrlCreateLabel("Round", 20, 20, 40, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")
GUICtrlCreateLabel("1", 34, 43, 30, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")
GUICtrlCreateLabel("2", 34, 73, 30, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")
GUICtrlCreateLabel("3", 34, 103, 30, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")
GUICtrlCreateLabel("4", 34, 133, 30, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")
GUICtrlCreateLabel("5", 34, 163, 30, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")

GUICtrlCreateLabel("Total Score", 70, 20, 70, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")
$cScore1 = GUICtrlCreateInput("", 85, 40, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter your final score")
$cScore2 = GUICtrlCreateInput("", 85, 70, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter your final score")
$cScore3 = GUICtrlCreateInput("", 85, 100, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter your final score")
$cScore4 = GUICtrlCreateInput("", 85, 130, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter your final score")
$cScore5 = GUICtrlCreateInput("", 85, 160, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter your final score")

GUICtrlCreateLabel("USGA Course Rating", 150, 20, 120, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")
$cCourse1 = GUICtrlCreateInput("72", 190, 40, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course rating")
$cCourse2 = GUICtrlCreateInput("72", 190, 70, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course rating")
$cCourse3 = GUICtrlCreateInput("72", 190, 100, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course rating")
$cCourse4 = GUICtrlCreateInput("72", 190, 130, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course rating")
$cCourse5 = GUICtrlCreateInput("72", 190, 160, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course rating")

GUICtrlCreateLabel("USGA Slope Rating", 280, 20, 120, 20)
GUICtrlSetFont(-1, 8.5, 600, "Tahoma")
$cSlope1 = GUICtrlCreateInput("113", 315, 40, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course slope")
$cSlope2 = GUICtrlCreateInput("113", 315, 70, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course slope")
$cSlope3 = GUICtrlCreateInput("113", 315, 100, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course slope")
$cSlope4 = GUICtrlCreateInput("113", 315, 130, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course slope")
$cSlope5 = GUICtrlCreateInput("113", 315, 160, 40, 20, BitOR($ES_NUMBER, $ES_CENTER))
GUICtrlSetTip(-1, "Enter course slope")

GUICtrlCreateGroup("Handicap", 10, 200, 100, 40)
$cHandiCap = GUICtrlCreateLabel("0", 15, 216, 90, 17, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, "Tahoma")

$bClear = GUICtrlCreateButton("Clear", 150, 208, 70, 30, $BS_ICON)
GUICtrlSetTip(-1, "Clear all values")
GUICtrlSetImage(-1, "shell32.dll", 31, 0)
$bCalculate = GUICtrlCreateButton("Calculate", 235, 208, 70, 30, BitOR($BS_DEFPUSHBUTTON, $BS_ICON))
GUICtrlSetTip(-1, "Calculate handicap")
GUICtrlSetImage(-1, "shell32.dll", 21, 0)
$bQuit = GUICtrlCreateButton("Quit", 320, 208, 70, 30, $BS_ICON)
GUICtrlSetTip(-1, "Exit")
GUICtrlSetImage(-1, "shell32.dll", 131, 0)

GUISetState()
While 1
	$msg = GUIGetMsg()
	Select
		Case $msg = $bClear
			_ClearAllFields()
		Case $msg = $bCalculate
			_Calculate()
		Case $msg = $cAboutItem
			_HelpAbout()
		Case $msg = $GUI_EVENT_CLOSE Or $msg = $bQuit Or $msg = $cExitItem
			Exit
	EndSelect
WEnd

Func _ClearAllFields()
	
	;MsgBox features: Title=Yes, Text=Yes, Buttons=Yes and No, Icon=Question, Modality=Task Modal, Miscellaneous=Top-most attribute
	Dim $iMsgBoxAnswer
	$iMsgBoxAnswer = MsgBox(270372, "Clear", "Clear using defaults?")
	Select
		Case $iMsgBoxAnswer = 6 ;Yes
			$sDefCourse = "72"
			$sDefSlope = "113"
		Case $iMsgBoxAnswer = 7 ;No
			$sDefCourse = ""
			$sDefSlope = ""
	EndSelect
	$iDifferential1 = 0
	$iDifferential2 = 0
	$iDifferential3 = 0
	$iDifferential4 = 0
	$iDifferential5 = 0
	GUICtrlSetData($cScore1, "")
	GUICtrlSetData($cScore2, "")
	GUICtrlSetData($cScore3, "")
	GUICtrlSetData($cScore4, "")
	GUICtrlSetData($cScore5, "")
	GUICtrlSetData($cCourse1, $sDefCourse)
	GUICtrlSetData($cCourse2, $sDefCourse)
	GUICtrlSetData($cCourse3, $sDefCourse)
	GUICtrlSetData($cCourse4, $sDefCourse)
	GUICtrlSetData($cCourse5, $sDefCourse)
	GUICtrlSetData($cSlope1, $sDefSlope)
	GUICtrlSetData($cSlope2, $sDefSlope)
	GUICtrlSetData($cSlope3, $sDefSlope)
	GUICtrlSetData($cSlope4, $sDefSlope)
	GUICtrlSetData($cSlope5, $sDefSlope)
	GUICtrlSetData($cHandiCap, "0")
	
EndFunc   ;==>_ClearAllFields

Func _Calculate()
	
	$iDifferential1 = (GUICtrlRead($cScore1) - GUICtrlRead($cCourse1)) * 113 / GUICtrlRead($cSlope1)
	$iDifferential2 = (GUICtrlRead($cScore2) - GUICtrlRead($cCourse2)) * 113 / GUICtrlRead($cSlope2)
	$iDifferential3 = (GUICtrlRead($cScore3) - GUICtrlRead($cCourse3)) * 113 / GUICtrlRead($cSlope3)
	$iDifferential4 = (GUICtrlRead($cScore4) - GUICtrlRead($cCourse4)) * 113 / GUICtrlRead($cSlope4)
	$iDifferential5 = (GUICtrlRead($cScore5) - GUICtrlRead($cCourse5)) * 113 / GUICtrlRead($cSlope5)
	
	Select
		Case $iDifferential1 < $iDifferential2 And $iDifferential1 < $iDifferential3 And $iDifferential1 < $iDifferential4 And $iDifferential1 < $iDifferential5
			$iHandiCap = $iDifferential1 * 0.96
			;MsgBox(0, "Debug", "Differential 1: " & $iDifferential1 & @LF & "HandiCap: " & $iHandiCap)
		Case $iDifferential2 < $iDifferential1 And $iDifferential2 < $iDifferential3 And $iDifferential2 < $iDifferential4 And $iDifferential2 < $iDifferential5
			$iHandiCap = $iDifferential2 * 0.96
			;MsgBox(0, "Debug", "Differential 2: " & $iDifferential2 & @LF & "HandiCap: " & $iHandiCap)
		Case $iDifferential3 < $iDifferential1 And $iDifferential3 < $iDifferential2 And $iDifferential3 < $iDifferential4 And $iDifferential3 < $iDifferential5
			$iHandiCap = $iDifferential3 * 0.96
			;MsgBox(0, "Debug", "Differential 3: " & $iDifferential3 & @LF & "HandiCap: " & $iHandiCap)
		Case $iDifferential4 < $iDifferential1 And $iDifferential4 < $iDifferential2 And $iDifferential4 < $iDifferential3 And $iDifferential4 < $iDifferential5
			$iHandiCap = $iDifferential4 * 0.96
			;MsgBox(0, "Debug", "Differential 4: " & $iDifferential4 & @LF & "HandiCap: " & $iHandiCap)
		Case $iDifferential5 < $iDifferential1 And $iDifferential5 < $iDifferential2 And $iDifferential5 < $iDifferential3 And $iDifferential5 < $iDifferential4
			$iHandiCap = $iDifferential5 * 0.96
			;MsgBox(0, "Debug", "Differential 5: " & $iDifferential5 & @LF & "HandiCap: " & $iHandiCap)
	EndSelect
	
	$iHandiCap = Round($iHandiCap, 0)
	GUICtrlSetData($cHandiCap, $iHandiCap)
	
EndFunc   ;==>_Calculate

Func _HelpAbout()
	
	$sHelpAboutTitle = "About Golf Handicap Calculator"
	$iHelpAboutWidth = 419 ; -1 = 400
	$iHelpAboutHeight = 370 ; -1 = 400
	$iHelpAboutLeftPos = -1 ;-1 is Center
	$iHelpAboutTopPos = -1 ;-1 is Center
	$iHelpAboutStyle = $WS_SYSMENU ;-1 is default which is: $WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU
	$iHelpAboutExStyle = -1 ; -1 is default
	
	$cHelpAboutHandle = GUICreate($sHelpAboutTitle, $iHelpAboutWidth, $iHelpAboutHeight, $iHelpAboutLeftPos, $iHelpAboutTopPos, $iHelpAboutStyle, $iHelpAboutExStyle)
	
	GUICtrlCreatePic(@ScriptDir & "\GolfName.jpg", -1, -1, 414, 77)
	GUICtrlCreateIcon(@ScriptDir & "\Golf.ico", 0, 11, 89, 32, 33)
	GUICtrlCreateLabel("Golf Handicap Calculator", 53, 89, 300, 16)
	GUICtrlCreateLabel("Version 1.0.0.0 (AutoIT Build: " & @AutoItVersion & ")", 53, 106, 353, 16)
	GUICtrlCreateLabel("Freeware product built using ", 53, 122, 135, 16) ;
	$cLink = GUICtrlCreateLabel("AutoIT v3.1.0", 190, 122, 65, 16)
	GUICtrlSetFont(-1, 8.5, 400, 4)
	GUICtrlSetColor(-1, 0x0000ff)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateLabel("", 53, 138, 270, 33)
	GUICtrlCreateLabel("This product is not under any license agreement and may be used freely by:", 53, 171, 270, 33)
	GUICtrlCreateLabel(@UserName, 68, 203, 270, 16)
	GUICtrlCreateLabel(@ComputerName, 68, 219, 270, 16)
	GUICtrlCreateLabel("", 53, 239, 351, 2, $SS_ETCHEDFRAME)
	GUICtrlCreateLabel("Disclaimer: This handicap calculation is only an estimate. Official United States Golf Association (USGA) handicaps can only be given out by authorized USGA clubs.", 53, 247, 350, 40)
	
	$cAboutOK = GUICtrlCreateButton("OK", 330, 300, 75, 23)
		
	GUISetState()
	
	While 1
		$msg = GUIGetMsg()
		$aAbout = GUIGetCursorInfo($cHelpAboutHandle)
		If $msg = $GUI_EVENT_CLOSE Or $msg = $cAboutOK Then
			GUIDelete()
			ExitLoop
		EndIf
		If $aAbout[4] = $cLink And $aAbout[2] = 1 Then
			Run(@ComSpec & " /c start " & "http://www.autoitscript.com/", "", @SW_HIDE)
		EndIf
	WEnd
	Return
	
EndFunc   ;==>_HelpAbout

